;; -*-asm-*-
;; $Id: highlevel.inc,v 1.1 2011/04/24 09:53:42 az Exp $
;; slightly more high-level conditionals

;; jump if zero/nonzero (gpasm hat BZ,BNZ)
JZ	macro	target
	btfsc	STATUS,Z
	goto	target
	endm

JNZ	macro	target
	btfss	STATUS,Z
	goto	target
	endm

;; jump if W equal/nonequal value (destroys W)
JE	macro	value, target
	sublw	value
	btfsc	STATUS,Z
	goto	target
	endm

JNE	macro 	value,target
	sublw	value
	btfss	STATUS,Z
	goto	target
	endm

;; jump if W less than (or equal to) value (destroys W)
JLE	macro	value,target
	sublw	value		;w=value-w, cond met: w zero or pos, carry=1
	btfsc	STATUS,C
	goto	target
	endm
;; jump if W strictly greater than value (destroys W)
JGT	macro	value,target
	sublw	value		; w=value-w, if cond met: w neg, carry=0
	btfss	STATUS,C
	goto	target
	endm
;; jump if W strictly less than value (destroys W)
JLT	macro	value,target
	JLE	(value-1),target
	endm
;; jump if W greater than (or equal to) value
JGE	macro	value,target
	JGT	(value-1),target
	endm
	
	
	

	
